' TEMPLATE

' NOTE: This file is generated automatically. Do not make modifications
' outside the designated areas; if you do, your changes may be lost.


' private helper class
class CatchModeChange extends DataEventHandler
  myVehicle as Vehicle

  sub handle(name as string, data as EventData)
    call myVehicle.setWireColor(data.getInt())
  end sub 'handle
end class 'CatchModeChange

  ' *** place user const declarations here ***
  ' *** end of user const declarations ***

class CenterGuard extends Vehicle
    sys as VehicleSystemObject
    
    Thruster1 as Thruster
    Thruster2 as Thruster
    Thruster3 as Thruster
    Thruster4 as Thruster
    Brake1 as Brake
    Brake2 as Brake
    Brake3 as Brake
    Brake4 as Brake
    WaypointSensor1 as WaypointSensor
    Broadcast1 as Broadcast
    Broadcast2 as Broadcast
    Compare1 as Compare
    Trigonometry1 as Trigonometry
    Multiply1 as Multiply
    Multiply2 as Multiply

  ' *** place vehicle data and subs here ***
  ' *** end of vehicle data and subs ***

    public function getGroup() as string
        getGroup = "Sports"
    end function 'getGroup

    public function getVer() as float
        getVer = 1.01
    end function 'getVer

    public sub Multiply2_Change_wires()
        ' wire Wire17 is a copy wire
        call Thruster1.setThrust(Multiply2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire18 is a copy wire
        call Thruster2.setThrust(Multiply2.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Multiply2_Change_wires

    public sub Multiply1_Change_wires()
        ' wire Wire15 is a copy wire
        call Thruster3.setThrust(Multiply1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire16 is a copy wire
        call Thruster4.setThrust(Multiply1.Output)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Multiply1_Change_wires

    public sub Trigonometry1_Change_wires()
        ' wire Wire13 is a copy wire
        call Multiply1.setInput1(Trigonometry1.Sine)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire14 is a copy wire
        call Multiply2.setInput1(Trigonometry1.Cosine)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Trigonometry1_Change_wires

    public sub WaypointSensor1_Change_wires()
        ' wire Wire11 is a copy wire
        call Compare1.setInput1(WaypointSensor1.Distance)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire12 is a copy wire
        call Trigonometry1.setAngle(WaypointSensor1.Bearing)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'WaypointSensor1_Change_wires

    public sub Compare1_LessThan_wires()
        ' wire Wire10 is sendto wire
        call Broadcast2.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_LessThan_wires

    public sub Compare1_GreaterThan_wires()
        ' wire Wire9 is sendto wire
        call Broadcast1.Trigger()
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Compare1_GreaterThan_wires

    public sub Broadcast1_Set_wires()
        ' wire Wire5 is sendto wire
        call Brake2.setPressure(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire6 is sendto wire
        call Brake4.setPressure(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire7 is sendto wire
        call Brake3.setPressure(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire8 is sendto wire
        call Brake1.setPressure(100)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Broadcast1_Set_wires

    public sub Broadcast2_Set_wires()
        ' wire Wire1 is sendto wire
        call Brake1.setPressure(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire2 is sendto wire
        call Brake3.setPressure(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire3 is sendto wire
        call Brake4.setPressure(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

        ' wire Wire4 is sendto wire
        call Brake2.setPressure(0)
  ' *** place custom wire behavior here ***
  ' *** end of custom wire behavior ***

    end sub 'Broadcast2_Set_wires

    public function getChassisName() as string
        getChassisName = "PuckChassis"
    end function

    public function getDescription() as string
        getDescription = "Created by Demolisher, based on PuckChassis."
    end function

    public function specifyComponents() as string
        specifyComponents = "PuckChassis Thruster Thruster Thruster Thruster Brake Brake Brake Brake WaypointSensor Broadcast Broadcast Compare Trigonometry Multiply Multiply"
    end function
  
    function loadComponents(vehicleID as integer) as boolean
        loadComponents = false
        if not super.loadComponents(vehicleID) then
           exit function
        end if

        compRegistry as VehicleComponents
        compRegistry = sys.getNamedData("VehicleComponents", "VehicleComponents", mSelf)
        if compRegistry <> null then
           call compRegistry.setVehicleName("CenterGuard")
        end if

        modeEvent as DataEvent
        ' magic object shared with mode-switch component(s)
        modeEvent = sys.getNamedData("DataEvent", "ModeChange", mSelf)
        if modeEvent = null then
           call sys.printToLog("Vehicle CenterGuard can't get ModeChange event!")
        else
           modeCatcher as CatchModeChange
           modeCatcher = new CatchModeChange        ' get handler
           modeCatcher.myVehicle = this             ' bind myself
           call modeEvent.register(modeCatcher)     ' then register handler
        end if

        ' initialize Thruster1
        Thruster1 = sys.getComponent("Thruster")
        if Thruster1 = null then
           call sys.printToLog("CenterGuard: Thruster1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Thruster1, "Thruster", "Thruster1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Thruster1, 0, 0.05, 0) then
            call sys.printToLog("CenterGuard: Thruster1 not placed")
            exit function
        end if
        call Thruster1.setThrust(100)

        ' initialize Thruster2
        Thruster2 = sys.getComponent("Thruster")
        if Thruster2 = null then
           call sys.printToLog("CenterGuard: Thruster2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Thruster2, "Thruster", "Thruster2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Thruster2, 0, -0.05, 0) then
            call sys.printToLog("CenterGuard: Thruster2 not placed")
            exit function
        end if
        call Thruster2.setThrust(100)

        ' initialize Thruster3
        Thruster3 = sys.getComponent("Thruster")
        if Thruster3 = null then
           call sys.printToLog("CenterGuard: Thruster3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Thruster3, "Thruster", "Thruster3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Thruster3, 0.05, 0, 1) then
            call sys.printToLog("CenterGuard: Thruster3 not placed")
            exit function
        end if
        call Thruster3.setThrust(100)

        ' initialize Thruster4
        Thruster4 = sys.getComponent("Thruster")
        if Thruster4 = null then
           call sys.printToLog("CenterGuard: Thruster4 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Thruster4, "Thruster", "Thruster4")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Thruster4, -0.05, 0, 1) then
            call sys.printToLog("CenterGuard: Thruster4 not placed")
            exit function
        end if
        call Thruster4.setThrust(100)

        ' initialize Brake1
        Brake1 = sys.getComponent("Brake")
        if Brake1 = null then
           call sys.printToLog("CenterGuard: Brake1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Brake1, "Brake", "Brake1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Brake1, 0.05, 0.05, 0) then
            call sys.printToLog("CenterGuard: Brake1 not placed")
            exit function
        end if
        call Brake1.setPressure(100)

        ' initialize Brake2
        Brake2 = sys.getComponent("Brake")
        if Brake2 = null then
           call sys.printToLog("CenterGuard: Brake2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Brake2, "Brake", "Brake2")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Brake2, 0.05, -0.05, 0) then
            call sys.printToLog("CenterGuard: Brake2 not placed")
            exit function
        end if
        call Brake2.setPressure(100)

        ' initialize Brake3
        Brake3 = sys.getComponent("Brake")
        if Brake3 = null then
           call sys.printToLog("CenterGuard: Brake3 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Brake3, "Brake", "Brake3")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Brake3, -0.05, 0.05, 0) then
            call sys.printToLog("CenterGuard: Brake3 not placed")
            exit function
        end if
        call Brake3.setPressure(100)

        ' initialize Brake4
        Brake4 = sys.getComponent("Brake")
        if Brake4 = null then
           call sys.printToLog("CenterGuard: Brake4 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Brake4, "Brake", "Brake4")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(Brake4, -0.05, -0.05, 0) then
            call sys.printToLog("CenterGuard: Brake4 not placed")
            exit function
        end if
        call Brake4.setPressure(100)

        ' initialize WaypointSensor1
        WaypointSensor1 = sys.getComponent("WaypointSensor")
        if WaypointSensor1 = null then
           call sys.printToLog("CenterGuard: WaypointSensor1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(WaypointSensor1, "WaypointSensor", "WaypointSensor1")
        end if
        ' Physical component needs to be positioned
        if not sys.placePhysicalComponent(WaypointSensor1, 0, 0, 0) then
            call sys.printToLog("CenterGuard: WaypointSensor1 not placed")
            exit function
        end if
        call WaypointSensor1.setCurrentWaypoint(1)
        call WaypointSensor1.setWaypointList("a")

        ' initialize Broadcast1
        Broadcast1 = sys.getComponent("Broadcast")
        if Broadcast1 = null then
           call sys.printToLog("CenterGuard: Broadcast1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Broadcast1, "Broadcast", "Broadcast1")
        end if
        ' Logical component doesn't need to be positioned

        ' initialize Broadcast2
        Broadcast2 = sys.getComponent("Broadcast")
        if Broadcast2 = null then
           call sys.printToLog("CenterGuard: Broadcast2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Broadcast2, "Broadcast", "Broadcast2")
        end if
        ' Logical component doesn't need to be positioned

        ' initialize Compare1
        Compare1 = sys.getComponent("Compare")
        if Compare1 = null then
           call sys.printToLog("CenterGuard: Compare1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Compare1, "Compare", "Compare1")
        end if
        ' Logical component doesn't need to be positioned
        call Compare1.setInput1(0)
        call Compare1.setInput2(0.8)
        call Compare1.setCalc(1)

        ' initialize Trigonometry1
        Trigonometry1 = sys.getComponent("Trigonometry")
        if Trigonometry1 = null then
           call sys.printToLog("CenterGuard: Trigonometry1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Trigonometry1, "Trigonometry", "Trigonometry1")
        end if
        ' Logical component doesn't need to be positioned
        call Trigonometry1.setAngle(0)

        ' initialize Multiply1
        Multiply1 = sys.getComponent("Multiply")
        if Multiply1 = null then
           call sys.printToLog("CenterGuard: Multiply1 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Multiply1, "Multiply", "Multiply1")
        end if
        ' Logical component doesn't need to be positioned
        call Multiply1.setInput1(0)
        call Multiply1.setInput2(120)

        ' initialize Multiply2
        Multiply2 = sys.getComponent("Multiply")
        if Multiply2 = null then
           call sys.printToLog("CenterGuard: Multiply2 not loaded")
           exit function
        end if

        if compRegistry <> null then
           call compRegistry.addComponent(Multiply2, "Multiply", "Multiply2")
        end if
        ' Logical component doesn't need to be positioned
        call Multiply2.setInput1(0)
        call Multiply2.setInput2(120)

        call Multiply2.Change.register(Multiply2_Change_wires)
        call Multiply1.Change.register(Multiply1_Change_wires)
        call Trigonometry1.Change.register(Trigonometry1_Change_wires)
        call WaypointSensor1.Change.register(WaypointSensor1_Change_wires)
        call Compare1.LessThan.register(Compare1_LessThan_wires)
        call Compare1.GreaterThan.register(Compare1_GreaterThan_wires)
        call Broadcast1.Set.register(Broadcast1_Set_wires)
        call Broadcast2.Set.register(Broadcast2_Set_wires)

  ' *** place user initialization here ***
  ' *** end of user initialization ***

        loadComponents = true           ' if we got this far, we succeeded
    end function 'loadComponents

    sub init(sysobj as VehicleSystemObject)
        sys = sysobj
  ' *** place user variable init here ***
  ' *** end of user variable init ***
    end sub 'init

end class 'CenterGuard
' END TEMPLATE
